"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _interopRequireWildcard2 = _interopRequireDefault(require("@babel/runtime/helpers/interopRequireWildcard"));

var _plugin = _interopRequireDefault(require("@start/plugin"));

var _default = userOptions => (0, _plugin.default)('typescriptCheck', () => async () => {
  const {
    default: execa
  } = await Promise.resolve().then(() => (0, _interopRequireWildcard2.default)(require('execa')));
  const options = { ...userOptions,
    project: '.',
    noEmit: true
  };
  const tscArgs = Object.keys(options).reduce((result, key) => {
    const value = options[key];

    if (typeof value === 'boolean') {
      return result.concat(`--${key}`);
    }

    if (typeof value === 'string') {
      return result.concat(`--${key}`, `${value}`);
    }

    if (Array.isArray(value)) {
      return result.concat(`--${key}`, `${value.join(',')}`);
    }

    return result;
  }, []);
  await execa('tsc', tscArgs, {
    stdout: process.stdout,
    stderr: process.stderr
  });
});

exports.default = _default;